<template>
  <div style="padding: 20px; padding-top: 0" class="reporttablecardxm">
    <div
      style="position: absolute; padding-top: 10px; line-height: 32px"
      class="header_sd-header_common"
    >
      <div :class="$style.titlepoint"></div>
      <span :class="['toptitle', $style.toptitle]">问题整改列表</span>
    </div>
    <sd-data-table
      ref="dataTable"
      :projectlist="true"
      :columns="columns"
      :data-url="dataUrl"
      :actions="actions"
      :process-req="processReq"
      :process-res="processRes"
      :defultpagination-pagesize="50"
    />
  </div>
</template>

<script>
import { Message } from 'ant-design-vue'
import TableActionTypes from '@/common/services/table-action-types'
import download from '@/common/services/download'
import StatisticsService from './iam-audit-dsc-service'
import components from './_import-components/iam-audit-dsc-rectify-list-import'
const columns = [
  {
    title: '序号',
    customRender: (text, record, index) => `${index + 1}`,
    width: '80px',
  },
  {
    title: '审计机构',
    dataIndex: 'UNIT_NAME',
    width: '200px',
  },
  {
    title: '项目名称',
    dataIndex: 'PROJECT_TITLE',
    width: '200px',
  },
  {
    title: '审计类型',
    dataIndex: 'AUDIT_TYPE',
    width: '200px',
  },
  {
    title: '问题名称（定性描述）',
    dataIndex: 'FIND_TITLE',
    width: '200px',
  },
  {
    title: '审计问题描述',
    dataIndex: 'FIND_DESC',
    width: '180px',
  },
  {
    title: '整改责任主体',
    dataIndex: 'RESP_UNIT_NAME',
    width: '180px',
  },
  {
    title: '问题分类',
    dataIndex: 'PROBLEM_CATEGORY_FUNCTION',
    width: '150px',
  },
  // {
  //   title: '整改单位',
  //   dataIndex: 'RESP_UNIT_NAME',
  //   width: '200px',
  // },
  {
    title: '问题类型',
    dataIndex: 'RECT_TYPE',
    width: '150px',
  },
  {
    title: '措施执行情况',
    dataIndex: 'DRAFT_RECT_MEASURE',
    width: '150px',
  },
  {
    title: '计划完成日期',
    dataIndex: 'DRAFT_FINISH_DATE',
    width: '150px',
  },
  {
    title: '整改状态',
    dataIndex: 'RECT_STATE',
    width: '150px',
  },
  // {
  //   title: '整改措施',
  //   dataIndex: 'MEASURE',
  //   width: '150px',
  // },
  {
    title: '是否完成当年整改阶段目标',
    dataIndex: 'WHETHER_FINISH_TARGET',
    width: '180px',
  },
  {
    title: '整改完成日期',
    dataIndex: 'FINISH_DATE',
    width: '150px',
  },
  // {
  //   title: '整改责任部门',
  //   dataIndex: 'RESPONSIBLE_DEPT_NAME',
  //   width: '100px',
  // },
  // {
  //   title: '整改类别',
  //   dataIndex: 'RECT_TYPE',
  //   width: '150px',
  // },
  // {
  //   title: '问题性质',
  //   dataIndex: 'PROBLEM_NATURE',
  //   width: '150px',
  // },
  {
    title: '销号状态',
    dataIndex: 'CANCELL_STATUS',
    width: '150px',
  },
]
export default {
  name: 'IamAuditDscRectifyList',
  metaInfo: {
    title: '整改发现统计透视图',
  },
  components,
  data() {
    return {
      params: null,
      columns,
      data: [],
      actions: [
        {
          label: '导出',
          id: 'export',
          permission: null,
          type: TableActionTypes.primary,
          callback: () => {
            // 整改发现列表导出
            const params = JSON.parse(this.$route.query.params)
            // 到期整改的问题数量
            if (this.$route.query.type === 'rectlist') {
              StatisticsService.exportRectifyList(params)
                .then((data) => {
                  const url = URL.createObjectURL(data)
                  download(url, '到期整改问题列表导出.xls')
                })
                .catch(() => {
                  Message.error('导出失败')
                })
            } // 整改中问题
            else if (this.$route.query.type === 'rectinglist') {
              StatisticsService.exportRectifyList(params)
                .then((data) => {
                  const url = URL.createObjectURL(data)
                  download(url, '整改中问题列表导出.xls')
                })
                .catch(() => {
                  Message.error('导出失败')
                })
            }
          },
        },
      ],
    }
  },
  computed: {
    dataUrl() {
      return 'api/xcoa-mobile/v1/spicDecisionSupportCenter/getFindRectifyList'
    },
  },
  methods: {
    processRes(res) {
      return res
    },
    processReq(req) {
      const params = JSON.parse(this.$route.query.params)
      req.data = {
        ...req.data,
        ...params,
      }
      if (req.data.pageIndex === undefined) {
        req.data.pageIndex = req.data.startPosition
      }

      if (req.data.pageSize === undefined) {
        req.data.pageSize = 10
      }
      this.params = req.data
      return req
    },
  },
}
</script>

<style module lang="scss">
@use '@/common/design' as *;
.titlepoint {
  position: absolute;
  top: 12px;
  left: 20px;
  width: 8px;
  height: 27px;
  background: #1890ff;
  border-radius: 8px;
}
.toptitle {
  position: absolute;
  top: 9px;
  left: 40px;
  width: 200px;
  font-size: 22px;
  font-weight: bold;
  color: #404040;
}
</style>
